<?php

namespace FiloBlu\OrderStatus\Setup;

use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

class UpgradeSchema implements UpgradeSchemaInterface {

    protected $_statusFactory;

    public function __construct(
    \Magento\Sales\Model\Order\StatusFactory $statusFactory
    ) {
        $this->_statusFactory = $statusFactory;
    }

    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context) {
        $installer = $setup;
        $installer->startSetup();

        if (version_compare($context->getVersion(), '2.2.0') < 0) {

            $manualReviewStatus = $this->_statusFactory->create();
            $manualReviewStatus->setData('status', 'manual_review');
            $manualReviewStatus->setData('label', 'Manual Review');
            $manualReviewStatus->save();
            $manualReviewStatus->assignState(\Magento\Sales\Model\Order::STATE_NEW, false, true);
        }
        $installer->endSetup();
    }

}
